module Encoding.UnixToUnix
  ( encuu
  , decuu
  ) where

import qualified Codec.Binary.Uu as UU
import Data.ByteString.UTF8 as BSU      -- from utf8-string
import qualified Data.ByteString.Char8 as C

import qualified Data.Text as T
import qualified Data.Text.Encoding as T
import qualified Data.Text.IO as T

decuu :: String -> String
-- decuu = C.unpack . U.fromRight . UU.decode . BSU.fromString
decuu input =
   case UU.decode (BSU.fromString input) of
     Right decoded -> T.unpack (T.decodeUtf8 decoded)
     Left _ -> "Error decoding UU.\n"

encuu :: String -> String
encuu = C.unpack . UU.encode . BSU.fromString

